Index: xorg-server-7.2.0.0-1.5.99.1/hw/kdrive/fake/fake.c
===================================================================
--- xorg-server-7.2.0.0-1.5.99.1.orig/hw/kdrive/fake/fake.c
+++ xorg-server-7.2.0.0-1.5.99.1/hw/kdrive/fake/fake.c
@@ -59,8 +59,10 @@ fakeScreenInitialize (KdScreenInfo *scre
 {
     if (!screen->width || !screen->height)
     {
-	screen->width = 1024;
-	screen->height = 768;
+	screen->width = 800;
+	screen->height = 600;
+	screen->width_mm = 212;
+	screen->height_mm = 159;
 	screen->rate = 72;
     }
 
@@ -70,7 +72,7 @@ fakeScreenInitialize (KdScreenInfo *scre
 	screen->height = 1;
     
     if (!screen->fb[0].depth)
-	screen->fb[0].depth = 16;
+	screen->fb[0].depth = 24;
 
     if (screen->fb[0].depth <= 8)
     {
Index: xorg-server-7.2.0.0-1.5.99.1/hw/kdrive/fake/fakeinit.c
===================================================================
--- xorg-server-7.2.0.0-1.5.99.1.orig/hw/kdrive/fake/fakeinit.c
+++ xorg-server-7.2.0.0-1.5.99.1/hw/kdrive/fake/fakeinit.c
@@ -78,6 +78,72 @@ OsVendorInit (void)
     KdOsInit (&FakeOsFuncs);
 }
 
+static Bool
+fakeRealizeCursor (DeviceIntPtr pDev,
+		   ScreenPtr    pScreen,
+		   CursorPtr    pCursor)
+{
+    return TRUE;
+}
+
+static Bool
+fakeUnrealizeCursor (DeviceIntPtr pDev,
+		     ScreenPtr    pScreen,
+		     CursorPtr    pCursor)
+{
+    return TRUE;
+}
+
+static void
+fakeSetCursor (DeviceIntPtr pDev,
+	       ScreenPtr    pScreen,
+	       CursorPtr    pCursor,
+	       int          x,
+	       int          y)
+{
+}
+
+static void
+fakeMoveCursor (DeviceIntPtr pDev,
+		ScreenPtr    pScreen,
+		int          x,
+		int          y)
+{
+}
+
+static Bool
+fakeDeviceCursorInitialize (DeviceIntPtr pDev,
+			    ScreenPtr    pScreen)
+{
+    return TRUE;
+}
+
+static void
+fakeDeviceCursorCleanup (DeviceIntPtr pDev,
+			 ScreenPtr    pScreen)
+{
+}
+
+static miPointerSpriteFuncRec fakePointerSpriteFuncs = {
+    fakeRealizeCursor,
+    fakeUnrealizeCursor,
+    fakeSetCursor,
+    fakeMoveCursor,
+    fakeDeviceCursorInitialize,
+    fakeDeviceCursorCleanup
+};
+
+static Bool
+fakeCursorInit (ScreenPtr pScreen)
+{
+    miPointerInitialize (pScreen,
+			 &fakePointerSpriteFuncs,
+			 &kdPointerScreenFuncs,
+			 FALSE);
+
+    return TRUE;
+}
+
 KdCardFuncs	fakeFuncs = {
     fakeCardInit,	    /* cardinit */
     fakeScreenInit,	    /* scrinit */
@@ -91,8 +157,8 @@ KdCardFuncs	fakeFuncs = {
     fakeRestore,	    /* restore */
     fakeScreenFini,	    /* scrfini */
     fakeCardFini,	    /* cardfini */
-    
-    0,			    /* initCursor */
+
+    fakeCursorInit,         /* initCursor */
     0,			    /* enableCursor */
     0,			    /* disableCursor */
     0,			    /* finiCursor */
Index: xorg-server-7.2.0.0-1.5.99.1/hw/kdrive/fake/os.c
===================================================================
--- xorg-server-7.2.0.0-1.5.99.1.orig/hw/kdrive/fake/os.c
+++ xorg-server-7.2.0.0-1.5.99.1/hw/kdrive/fake/os.c
@@ -25,15 +25,248 @@
 #endif
 #include "fake.h"
 
+#include <errno.h>
+#include <signal.h>
+#include <linux/vt.h>
+#include <linux/kd.h>
+#include <sys/stat.h>
+#include <sys/ioctl.h>
+
+static int  vtno;
+int  LinuxConsoleFd;
+static int  activeVT;
+static Bool enabled;
+
+static void
+LinuxVTRequest (int sig)
+{
+    kdSwitchPending = TRUE;
+}
+
+/* Check before chowning -- this avoids touching the file system */
+static void
+LinuxCheckChown (char *file)
+{
+    struct stat	    st;
+    __uid_t	    u;
+    __gid_t	    g;
+
+    if (stat (file, &st) < 0)
+	return;
+    u = getuid ();
+    g = getgid ();
+    if (st.st_uid != u || st.st_gid != g)
+	chown (file, u, g);
+}
+
+static int
+LinuxInit (void)
+{
+    int fd = -1;
+    char vtname[11];
+    struct vt_stat vts;
+
+    LinuxConsoleFd = -1;
+    /* check if we're run with euid==0 */
+    if (geteuid() != 0)
+    {
+	FatalError("LinuxInit: Server must be suid root\n");
+    }
+
+    vtno = kdVirtualTerminal;
+
+    close(fd);
+
+    sprintf(vtname,"/dev/tty%d",vtno); /* /dev/tty1-64 */
+
+    if ((LinuxConsoleFd = open(vtname, O_RDWR|O_NDELAY, 0)) < 0)
+    {
+	FatalError("LinuxInit: Cannot open %s (%s)\n",
+		   vtname, strerror(errno));
+    }
+
+    /* change ownership of the vt */
+    LinuxCheckChown (vtname);
+
+    /*
+     * the current VT device we're running on is not "console", we want
+     * to grab all consoles too
+     *
+     * Why is this needed?
+     */
+    LinuxCheckChown ("/dev/tty0");
+    /*
+     * Linux doesn't switch to an active vt after the last close of a vt,
+     * so we do this ourselves by remembering which is active now.
+     */
+    memset (&vts, '\0', sizeof (vts));	/* valgrind */
+    if (ioctl(LinuxConsoleFd, VT_GETSTATE, &vts) == 0)
+    {
+	activeVT = vts.v_active;
+    }
+
+    return 1;
+}
+
+static void
+LinuxSetSwitchMode (int mode)
+{
+    struct sigaction	act;
+    struct vt_mode	VT;
+
+    if (ioctl(LinuxConsoleFd, VT_GETMODE, &VT) < 0)
+    {
+	FatalError ("LinuxInit: VT_GETMODE failed\n");
+    }
+
+    if (mode == VT_PROCESS)
+    {
+	act.sa_handler = LinuxVTRequest;
+	sigemptyset (&act.sa_mask);
+	act.sa_flags = 0;
+	sigaction (SIGUSR1, &act, 0);
+
+	VT.mode = mode;
+	VT.relsig = SIGUSR1;
+	VT.acqsig = SIGUSR1;
+    }
+    else
+    {
+	act.sa_handler = SIG_IGN;
+	sigemptyset (&act.sa_mask);
+	act.sa_flags = 0;
+	sigaction (SIGUSR1, &act, 0);
+
+	VT.mode = mode;
+	VT.relsig = 0;
+	VT.acqsig = 0;
+    }
+    if (ioctl(LinuxConsoleFd, VT_SETMODE, &VT) < 0)
+    {
+	FatalError("LinuxInit: VT_SETMODE failed\n");
+    }
+}
+
+#ifdef FNONBLOCK
+#define NOBLOCK FNONBLOCK
+#else
+#define NOBLOCK FNDELAY
+#endif
+
+static void
+LinuxEnable (void)
+{
+    if (enabled)
+	return;
+    if (kdSwitchPending)
+    {
+	kdSwitchPending = FALSE;
+	ioctl (LinuxConsoleFd, VT_RELDISP, VT_ACKACQ);
+    }
+
+    /*
+     * now get the VT
+     */
+    LinuxSetSwitchMode (VT_AUTO);
+    if (ioctl(LinuxConsoleFd, VT_ACTIVATE, vtno) != 0)
+    {
+	FatalError("LinuxInit: VT_ACTIVATE failed\n");
+    }
+    if (ioctl(LinuxConsoleFd, VT_WAITACTIVE, vtno) != 0)
+    {
+	FatalError("LinuxInit: VT_WAITACTIVE failed\n");
+    }
+    LinuxSetSwitchMode (VT_PROCESS);
+    if (ioctl(LinuxConsoleFd, KDSETMODE, KD_GRAPHICS) < 0)
+    {
+	FatalError("LinuxInit: KDSETMODE KD_GRAPHICS failed\n");
+    }
+    enabled = TRUE;
+}
+
+static void
+LinuxDisable (void)
+{
+    ioctl(LinuxConsoleFd, KDSETMODE, KD_TEXT);  /* Back to text mode ... */
+    if (kdSwitchPending)
+    {
+	kdSwitchPending = FALSE;
+	ioctl (LinuxConsoleFd, VT_RELDISP, 1);
+    }
+    enabled = FALSE;
+}
+
+static void
+LinuxFini (void)
+{
+    struct vt_mode   VT;
+    struct vt_stat  vts;
+    int		    fd;
+
+    if (LinuxConsoleFd < 0)
+	return;
+
+    if (ioctl(LinuxConsoleFd, VT_GETMODE, &VT) != -1)
+    {
+	VT.mode = VT_AUTO;
+	ioctl(LinuxConsoleFd, VT_SETMODE, &VT); /* set dflt vt handling */
+    }
+    memset (&vts, '\0', sizeof (vts));	/* valgrind */
+    ioctl (LinuxConsoleFd, VT_GETSTATE, &vts);
+    if (vtno == vts.v_active)
+    {
+	/*
+	 * Find a legal VT to switch to, either the one we started from
+	 * or the lowest active one that isn't ours
+	 */
+	if (activeVT < 0 ||
+	    activeVT == vts.v_active ||
+	    !(vts.v_state & (1 << activeVT)))
+	{
+	    for (activeVT = 1; activeVT < 16; activeVT++)
+		if (activeVT != vtno && (vts.v_state & (1 << activeVT)))
+		    break;
+	    if (activeVT == 16)
+		activeVT = -1;
+	}
+	/*
+	 * Perform a switch back to the active VT when we were started
+	 */
+	if (activeVT >= -1)
+	{
+	    ioctl (LinuxConsoleFd, VT_ACTIVATE, activeVT);
+	    ioctl (LinuxConsoleFd, VT_WAITACTIVE, activeVT);
+	    activeVT = -1;
+	}
+    }
+    close(LinuxConsoleFd);                /* make the vt-manager happy */
+    LinuxConsoleFd = -1;
+    fd = open ("/dev/tty0", O_RDWR|O_NDELAY, 0);
+    if (fd >= 0)
+    {
+	memset (&vts, '\0', sizeof (vts));	/* valgrind */
+	ioctl (fd, VT_GETSTATE, &vts);
+	if (ioctl (fd, VT_DISALLOCATE, vtno) < 0)
+	    fprintf (stderr, "Can't deallocate console %d %s\n", vtno, strerror(errno));
+	close (fd);
+    }
+    return;
+}
+
 static int
 FakeInit (void)
 {
+    if (kdVirtualTerminal >= 0)
+	return LinuxInit ();
+
     return 1;
 }
 
 static void
 FakeEnable (void)
 {
+    if (kdVirtualTerminal >= 0)
+	LinuxEnable ();
 }
 
 static Bool
@@ -45,11 +278,15 @@ FakeSpecialKey (KeySym sym)
 static void
 FakeDisable (void)
 {
+    if (kdVirtualTerminal >= 0)
+	LinuxDisable ();
 }
 
 static void
 FakeFini (void)
 {
+    if (kdVirtualTerminal >= 0)
+	return LinuxFini ();
 }
 
 KdOsFuncs   FakeOsFuncs = {
Index: xorg-server-7.2.0.0-1.5.99.1/hw/kdrive/src/kdrive.c
===================================================================
--- xorg-server-7.2.0.0-1.5.99.1.orig/hw/kdrive/src/kdrive.c
+++ xorg-server-7.2.0.0-1.5.99.1/hw/kdrive/src/kdrive.c
@@ -55,7 +55,7 @@ typedef struct _kdDepths {
 
 KdDepths    kdDepths[] = {
     { 1, 1 },
-    { 4, 4 },
+    { 4, 8 },
     { 8, 8 },
     { 15, 16 },
     { 16, 16 },
@@ -1394,6 +1394,7 @@ OsVendorFatalError(void)
 int
 DPMSSet(ClientPtr client, int level)
 {
+    return -1;
 }
 
 int
Index: xorg-server-7.2.0.0-1.5.99.1/include/dix-config.h.in
===================================================================
--- xorg-server-7.2.0.0-1.5.99.1.orig/include/dix-config.h.in
+++ xorg-server-7.2.0.0-1.5.99.1/include/dix-config.h.in
@@ -406,6 +406,9 @@
 /* Support HAL for hotplug */
 #undef CONFIG_HAL
 
+/* Support Avahi */
+#undef HAVE_AVAHI
+
 /* Use only built-in fonts */
 #undef BUILTIN_FONTS
 
Index: xorg-server-7.2.0.0-1.5.99.1/include/window.h
===================================================================
--- xorg-server-7.2.0.0-1.5.99.1.orig/include/window.h
+++ xorg-server-7.2.0.0-1.5.99.1/include/window.h
@@ -268,5 +268,7 @@ extern void DisableMapUnmapEvents(
     WindowPtr /* pWin */ );
 extern void EnableMapUnmapEvents(
     WindowPtr /* pWin */ );
+extern Bool MapUnmapEventsEnabled(
+    WindowPtr /* pWin */ );
 
 #endif /* WINDOW_H */
Index: xorg-server-7.2.0.0-1.5.99.1/mi/miinitext.c
===================================================================
--- xorg-server-7.2.0.0-1.5.99.1.orig/mi/miinitext.c
+++ xorg-server-7.2.0.0-1.5.99.1/mi/miinitext.c
@@ -49,6 +49,10 @@ SOFTWARE.
 #include <dix-config.h>
 #endif
 
+#ifndef XINPUT
+#define XINPUT
+#endif
+
 #ifdef HAVE_XORG_CONFIG_H
 #include <xorg-config.h>
 #endif
Index: xorg-server-7.2.0.0-1.5.99.1/miext/damage/damage.c
===================================================================
--- xorg-server-7.2.0.0-1.5.99.1.orig/miext/damage/damage.c
+++ xorg-server-7.2.0.0-1.5.99.1/miext/damage/damage.c
@@ -1411,11 +1411,17 @@ damageText (DrawablePtr	    pDrawable,
 	damageDamageChars (pDrawable, pGC->font, x + pDrawable->x, y + pDrawable->y, n,
 			   charinfo, imageblt, pGC->subWindowMode);
 	if (imageblt)
-	    (*pGC->ops->ImageGlyphBlt)(pDrawable, pGC, x, y, n, charinfo,
-				       FONTGLYPHS(pGC->font));
+	{
+	    if (pGC->ops->ImageGlyphBlt)
+		(*pGC->ops->ImageGlyphBlt)(pDrawable, pGC, x, y, n, charinfo,
+					   FONTGLYPHS(pGC->font));
+	}
 	else
-	    (*pGC->ops->PolyGlyphBlt)(pDrawable, pGC, x, y, n, charinfo,
-				      FONTGLYPHS(pGC->font));
+	{
+	    if (pGC->ops->PolyGlyphBlt)
+		(*pGC->ops->PolyGlyphBlt)(pDrawable, pGC, x, y, n, charinfo,
+					  FONTGLYPHS(pGC->font));
+	}
     }
     xfree(charinfo);
     return x + w;
@@ -1432,8 +1438,12 @@ damagePolyText8(DrawablePtr pDrawable,
     DAMAGE_GC_OP_PROLOGUE(pGC, pDrawable);
 
     if (checkGCDamage (pDrawable, pGC))
+    {
 	x = damageText (pDrawable, pGC, x, y, (unsigned long) count, chars,
 		    Linear8Bit, TT_POLY8);
+	if (!pGC->ops->PolyGlyphBlt)
+	    (*pGC->ops->PolyText8)(pDrawable, pGC, x, y, count, chars);
+    }
     else
 	x = (*pGC->ops->PolyText8)(pDrawable, pGC, x, y, count, chars);
     damageReportPostOp (pDrawable);
@@ -1452,9 +1462,13 @@ damagePolyText16(DrawablePtr	pDrawable,
     DAMAGE_GC_OP_PROLOGUE(pGC, pDrawable);
 
     if (checkGCDamage (pDrawable, pGC))
+    {
 	x = damageText (pDrawable, pGC, x, y, (unsigned long) count, (char *) chars,
 		    FONTLASTROW(pGC->font) == 0 ? Linear16Bit : TwoD16Bit,
 		    TT_POLY16);
+	if (!pGC->ops->PolyGlyphBlt)
+	    (*pGC->ops->PolyText16)(pDrawable, pGC, x, y, count, chars);
+    }
     else
 	x = (*pGC->ops->PolyText16)(pDrawable, pGC, x, y, count, chars);
     damageReportPostOp (pDrawable);
@@ -1473,8 +1487,12 @@ damageImageText8(DrawablePtr	pDrawable,
     DAMAGE_GC_OP_PROLOGUE(pGC, pDrawable);
 
     if (checkGCDamage (pDrawable, pGC))
+    {
 	damageText (pDrawable, pGC, x, y, (unsigned long) count, chars,
 		    Linear8Bit, TT_IMAGE8);
+	if (!pGC->ops->ImageGlyphBlt)
+	    (*pGC->ops->ImageText8)(pDrawable, pGC, x, y, count, chars);
+    }
     else
 	(*pGC->ops->ImageText8)(pDrawable, pGC, x, y, count, chars);
     damageReportPostOp (pDrawable);
@@ -1492,9 +1510,13 @@ damageImageText16(DrawablePtr	pDrawable,
     DAMAGE_GC_OP_PROLOGUE(pGC, pDrawable);
 
     if (checkGCDamage (pDrawable, pGC))
+    {
 	damageText (pDrawable, pGC, x, y, (unsigned long) count, (char *) chars,
 		    FONTLASTROW(pGC->font) == 0 ? Linear16Bit : TwoD16Bit,
 		    TT_IMAGE16);
+	if (!pGC->ops->ImageGlyphBlt)
+	    (*pGC->ops->ImageText16)(pDrawable, pGC, x, y, count, chars);
+    }
     else
 	(*pGC->ops->ImageText16)(pDrawable, pGC, x, y, count, chars);
     damageReportPostOp (pDrawable);
Index: xorg-server-7.2.0.0-1.5.99.1/randr/rrcrtc.c
===================================================================
--- xorg-server-7.2.0.0-1.5.99.1.orig/randr/rrcrtc.c
+++ xorg-server-7.2.0.0-1.5.99.1/randr/rrcrtc.c
@@ -24,6 +24,10 @@
 #include "swaprep.h"
 #include "registry.h"
 
+#ifdef PANORAMIX
+#include "panoramiXsrv.h"
+#endif
+
 RESTYPE	RRCrtcType;
 
 /*
@@ -795,13 +799,23 @@ ProcRRSetCrtcConfig (ClientPtr client)
 	{
 	    int source_width = mode->mode.width;
 	    int	source_height = mode->mode.height;
+	    int w = pScreen->width;
+	    int h = pScreen->height;
+
+#ifdef PANORAMIX
+	    if (!noPanoramiXExtension)
+	    {
+		w = PanoramiXPixWidth;
+		h = PanoramiXPixHeight;
+	    }
+#endif
 
 	    if ((rotation & 0xf) == RR_Rotate_90 || (rotation & 0xf) == RR_Rotate_270)
 	    {
 		source_width = mode->mode.height;
 		source_height = mode->mode.width;
 	    }
-	    if (stuff->x + source_width > pScreen->width)
+	    if (stuff->x + source_width > w)
 	    {
 		client->errorValue = stuff->x;
 		if (outputs)
@@ -809,7 +823,7 @@ ProcRRSetCrtcConfig (ClientPtr client)
 		return BadValue;
 	    }
 	    
-	    if (stuff->y + source_height > pScreen->height)
+	    if (stuff->y + source_height > h)
 	    {
 		client->errorValue = stuff->y;
 		if (outputs)
Index: xorg-server-7.2.0.0-1.5.99.1/randr/rrscreen.c
===================================================================
--- xorg-server-7.2.0.0-1.5.99.1.orig/randr/rrscreen.c
+++ xorg-server-7.2.0.0-1.5.99.1/randr/rrscreen.c
@@ -22,6 +22,10 @@
 
 #include "randrstr.h"
 
+#ifdef PANORAMIX
+#include "panoramiXsrv.h"
+#endif
+
 extern char	*ConnectionInfo;
 
 static int padlength[4] = {0, 3, 2, 1};
@@ -44,6 +48,16 @@ RREditConnectionInfo (ScreenPtr pScreen)
     xVisualType	    *visual;
     int		    screen = 0;
     int		    d;
+    int             w = pScreen->width;
+    int             h = pScreen->height;
+
+#ifdef PANORAMIX
+    if (!noPanoramiXExtension)
+    {
+	w = PanoramiXPixWidth;
+	h = PanoramiXPixHeight;
+    }
+#endif
 
     connSetup = (xConnSetup *) ConnectionInfo;
     vendor = (char *) connSetup + sizeof (xConnSetup);
@@ -66,8 +80,8 @@ RREditConnectionInfo (ScreenPtr pScreen)
 	root = (xWindowRoot *) ((char *) depth);
 	screen++;
     }
-    root->pixWidth = pScreen->width;
-    root->pixHeight = pScreen->height;
+    root->pixWidth = w;
+    root->pixHeight = h;
     root->mmWidth = pScreen->mmWidth;
     root->mmHeight = pScreen->mmHeight;
 }
@@ -77,6 +91,8 @@ RRSendConfigNotify (ScreenPtr pScreen)
 {
     WindowPtr	pWin = WindowTable[pScreen->myNum];
     xEvent	event;
+    int         w = pWin->drawable.width;
+    int         h = pWin->drawable.height;
 
     event.u.u.type = ConfigureNotify;
     event.u.configureNotify.window = pWin->drawable.id;
@@ -84,10 +100,16 @@ RRSendConfigNotify (ScreenPtr pScreen)
     event.u.configureNotify.x = 0;
     event.u.configureNotify.y = 0;
 
-    /* XXX xinerama stuff ? */
-    
-    event.u.configureNotify.width = pWin->drawable.width;
-    event.u.configureNotify.height = pWin->drawable.height;
+#ifdef PANORAMIX
+    if (!noPanoramiXExtension)
+    {
+	w = PanoramiXPixWidth;
+	h = PanoramiXPixHeight;
+    }
+#endif
+
+    event.u.configureNotify.width = w;
+    event.u.configureNotify.height = h;
     event.u.configureNotify.borderWidth = wBorderWidth (pWin);
     event.u.configureNotify.override = pWin->overrideRedirect;
     DeliverEvents(pWin, &event, 1, NullWindow);
@@ -100,6 +122,16 @@ RRDeliverScreenEvent (ClientPtr client,
     xRRScreenChangeNotifyEvent	se;
     RRCrtcPtr	crtc = pScrPriv->numCrtcs ? pScrPriv->crtcs[0] : NULL;
     WindowPtr	pRoot = WindowTable[pScreen->myNum];
+    int         w = pScreen->width;
+    int         h = pScreen->height;
+
+#ifdef PANORAMIX
+    if (!noPanoramiXExtension)
+    {
+	w = PanoramiXPixWidth;
+	h = PanoramiXPixHeight;
+    }
+#endif
     
     se.type = RRScreenChangeNotify + RREventBase;
     se.rotation = (CARD8) (crtc ? crtc->rotation : RR_Rotate_0);
@@ -118,13 +150,13 @@ RRDeliverScreenEvent (ClientPtr client,
     se.sizeID = RR10CurrentSizeID (pScreen);
 
     if (se.rotation & (RR_Rotate_90 | RR_Rotate_270)) {
-	se.widthInPixels = pScreen->height;
-	se.heightInPixels = pScreen->width;
+	se.widthInPixels = h;
+	se.heightInPixels = w;
 	se.widthInMillimeters = pScreen->mmHeight;
 	se.heightInMillimeters = pScreen->mmWidth;
     } else {
-	se.widthInPixels = pScreen->width;
-	se.heightInPixels = pScreen->height;
+	se.widthInPixels = w;
+	se.heightInPixels = h;
 	se.widthInMillimeters = pScreen->mmWidth;
 	se.heightInMillimeters = pScreen->mmHeight;
     }
@@ -140,19 +172,31 @@ RRDeliverScreenEvent (ClientPtr client,
 void
 RRScreenSizeNotify (ScreenPtr	pScreen)
 {
+    int w = pScreen->width;
+    int h = pScreen->height;
+
     rrScrPriv(pScreen);
+
+#ifdef PANORAMIX
+    if (!noPanoramiXExtension)
+    {
+	w = PanoramiXPixWidth;
+	h = PanoramiXPixHeight;
+    }
+#endif
+
     /*
      * Deliver ConfigureNotify events when root changes
      * pixel size
      */
-    if (pScrPriv->width == pScreen->width &&
-	pScrPriv->height == pScreen->height &&
+    if (pScrPriv->width == w &&
+	pScrPriv->height == h &&
 	pScrPriv->mmWidth == pScreen->mmWidth &&
 	pScrPriv->mmHeight == pScreen->mmHeight)
 	return;
     
-    pScrPriv->width = pScreen->width;
-    pScrPriv->height = pScreen->height;
+    pScrPriv->width = w;
+    pScrPriv->height = h;
     pScrPriv->mmWidth = pScreen->mmWidth;
     pScrPriv->mmHeight = pScreen->mmHeight;
     pScrPriv->changed = TRUE;
@@ -741,7 +785,7 @@ ProcRRSetScreenConfig (ClientPtr client)
     RRModePtr		    mode;
     RR10DataPtr		    pData = NULL;
     RRScreenSizePtr    	    pSize;
-    int			    width, height;
+    int			    width, height, w, h;
     
     UpdateCurrentTime ();
 
@@ -896,7 +940,19 @@ ProcRRSetScreenConfig (ClientPtr client)
 	width = mode->mode.height;
 	height = mode->mode.width;
     }
-    if (width != pScreen->width || height != pScreen->height)
+
+    w = pScreen->width;
+    h = pScreen->height;
+
+#ifdef PANORAMIX
+    if (!noPanoramiXExtension)
+    {
+	w = PanoramiXPixWidth;
+	h = PanoramiXPixHeight;
+    }
+#endif
+
+    if (width != w || height != h)
     {
 	int	c;
 
@@ -960,6 +1016,16 @@ RR10CurrentSizeID (ScreenPtr pScreen)
 {
     CARD16	sizeID = 0xffff;
     RROutputPtr output = RRFirstOutput (pScreen);
+    int         w = pScreen->width;
+    int         h = pScreen->height;
+
+#ifdef PANORAMIX
+    if (!noPanoramiXExtension)
+    {
+	w = PanoramiXPixWidth;
+	h = PanoramiXPixHeight;
+    }
+#endif
     
     if (output)
     {
@@ -968,8 +1034,8 @@ RR10CurrentSizeID (ScreenPtr pScreen)
 	{
 	    int i;
 	    for (i = 0; i < data->nsize; i++)
-		if (data->sizes[i].width == pScreen->width &&
-		    data->sizes[i].height == pScreen->height)
+		if (data->sizes[i].width == w &&
+		    data->sizes[i].height == h)
 		{
 		    sizeID = (CARD16) i;
 		    break;
Index: xorg-server-7.2.0.0-1.5.99.1/render/animcur.c
===================================================================
--- xorg-server-7.2.0.0-1.5.99.1.orig/render/animcur.c
+++ xorg-server-7.2.0.0-1.5.99.1/render/animcur.c
@@ -47,16 +47,6 @@
 #include "inputstr.h"
 #include "xace.h"
 
-typedef struct _AnimCurElt {
-    CursorPtr	pCursor;    /* cursor to show */
-    CARD32	delay;	    /* in ms */
-} AnimCurElt;
-
-typedef struct _AnimCur {
-    int		nelt;	    /* number of elements in the elts array */
-    AnimCurElt	*elts;	    /* actually allocated right after the structure */
-} AnimCurRec, *AnimCurPtr;
-
 typedef struct _AnimScrPriv {
     CursorPtr			pCursor;
     int				elt;
@@ -86,15 +76,13 @@ static AnimCurStateRec animCurState[MAX_
 
 static unsigned char empty[4];
 
-static CursorBits   animCursorBits = {
+CursorBits   animCursorBits = {
     empty, empty, 2, 1, 1, 0, 0, 1
 };
 
 static int AnimCurGeneration;
 static DevPrivateKey AnimCurScreenPrivateKey = &AnimCurScreenPrivateKey;
 
-#define IsAnimCur(c)	    ((c) && ((c)->bits == &animCursorBits))
-#define GetAnimCur(c)	    ((AnimCurPtr) ((c) + 1))
 #define GetAnimCurScreen(s) ((AnimCurScreenPtr)dixLookupPrivate(&(s)->devPrivates, AnimCurScreenPrivateKey))
 #define GetAnimCurScreenIfSet(s) GetAnimCurScreen(s)
 #define SetAnimCurScreen(s,p) dixSetPrivate(&(s)->devPrivates, AnimCurScreenPrivateKey, p)
@@ -286,10 +274,7 @@ AnimCurRealizeCursor (DeviceIntPtr pDev,
     Bool		ret;
     
     Unwrap (as, pScreen, RealizeCursor);
-    if (IsAnimCur(pCursor))
-	ret = TRUE;
-    else
-	ret = (*pScreen->RealizeCursor) (pDev, pScreen, pCursor);
+    ret = (*pScreen->RealizeCursor) (pDev, pScreen, pCursor);
     Wrap (as, pScreen, RealizeCursor, AnimCurRealizeCursor);
     return ret;
 }
@@ -303,6 +288,7 @@ AnimCurUnrealizeCursor (DeviceIntPtr pDe
     Bool		ret;
     
     Unwrap (as, pScreen, UnrealizeCursor);
+    ret = (*pScreen->UnrealizeCursor) (pDev, pScreen, pCursor);
     if (IsAnimCur(pCursor))
     {
         AnimCurPtr  ac = GetAnimCur(pCursor);
@@ -311,10 +297,7 @@ AnimCurUnrealizeCursor (DeviceIntPtr pDe
 	if (pScreen->myNum == 0)
 	    for (i = 0; i < ac->nelt; i++)
 		FreeCursor (ac->elts[i].pCursor, 0);
-	ret = TRUE;
     }
-    else
-	ret = (*pScreen->UnrealizeCursor) (pDev, pScreen, pCursor);
     Wrap (as, pScreen, UnrealizeCursor, AnimCurUnrealizeCursor);
     return ret;
 }
@@ -379,9 +362,11 @@ AnimCurInit (ScreenPtr pScreen)
 int
 AnimCursorCreate (CursorPtr *cursors, CARD32 *deltas, int ncursor, CursorPtr *ppCursor, ClientPtr client, XID cid)
 {
-    CursorPtr	pCursor;
-    int		rc, i;
-    AnimCurPtr	ac;
+    CursorPtr	 pCursor;
+    int		 rc, nscr, i;
+    AnimCurPtr	 ac;
+    ScreenPtr 	 pscr;
+    DeviceIntPtr pDev;
 
     for (i = 0; i < screenInfo.numScreens; i++)
 	if (!GetAnimCurScreenIfSet (screenInfo.screens[i]))
@@ -433,7 +418,54 @@ AnimCursorCreate (CursorPtr *cursors, CA
 	ac->elts[i].pCursor = cursors[i];
 	ac->elts[i].delay = deltas[i];
     }
-    
+
+    /*
+     * realize the cursor for every screen
+     * Do not change the refcnt, this will be changed when ChangeToCursor
+     * actually changes the sprite.
+     */
+    for (nscr = 0; nscr < screenInfo.numScreens; nscr++)
+    {
+        pscr = screenInfo.screens[nscr];
+        for (pDev = inputInfo.devices; pDev; pDev = pDev->next)
+        {
+            if (DevHasCursor(pDev))
+            {
+                if (!( *pscr->RealizeCursor)(pDev, pscr, pCursor))
+                {
+                    /* Realize failed for device pDev on screen pscr.
+                     * We have to assume that for all devices before, realize
+                     * worked. We need to rollback all devices so far on the
+                     * current screen and then all devices on previous
+                     * screens.
+                     */
+                    DeviceIntPtr pDevIt = inputInfo.devices; /*dev iterator*/
+                    while(pDevIt && pDevIt != pDev)
+                    {
+                        if (DevHasCursor(pDevIt))
+                            ( *pscr->UnrealizeCursor)(pDevIt, pscr, pCursor);
+                        pDevIt = pDevIt->next;
+                    }
+                    while (--nscr >= 0)
+                    {
+                        pscr = screenInfo.screens[nscr];
+                        /* now unrealize all devices on previous screens */
+                        pDevIt = inputInfo.devices;
+                        while (pDevIt)
+                        {
+                            if (DevHasCursor(pDevIt))
+                                ( *pscr->UnrealizeCursor)(pDevIt, pscr, pCursor);
+                            pDevIt = pDevIt->next;
+                        }
+                        ( *pscr->UnrealizeCursor)(pDev, pscr, pCursor);
+                    }
+                    dixFreePrivates(pCursor->devPrivates);
+		    xfree(pCursor);
+                    return BadAlloc;
+                }
+            }
+        }
+    }
     *ppCursor = pCursor;
     return Success;
 }
Index: xorg-server-7.2.0.0-1.5.99.1/render/glyph.c
===================================================================
--- xorg-server-7.2.0.0-1.5.99.1.orig/render/glyph.c
+++ xorg-server-7.2.0.0-1.5.99.1/render/glyph.c
@@ -422,6 +422,8 @@ AllocateGlyph (xGlyphInfo *gi, int fdept
 
     for (i = 0; i < screenInfo.numScreens; i++)
     {
+	*GetGlyphPrivatesForScreen (glyph, screenInfo.screens[i]) = NULL;
+
 	ps = GetPictureScreenIfSet (screenInfo.screens[i]);
 
 	if (ps)
Index: xorg-server-7.2.0.0-1.5.99.1/render/picturestr.h
===================================================================
--- xorg-server-7.2.0.0-1.5.99.1.orig/render/picturestr.h
+++ xorg-server-7.2.0.0-1.5.99.1/render/picturestr.h
@@ -26,6 +26,7 @@
 
 #include "scrnintstr.h"
 #include "glyphstr.h"
+#include "cursorstr.h"
 #include "resource.h"
 #include "privates.h"
 
@@ -620,6 +621,22 @@ PictureGradientColor (PictGradientStopPt
 
 void RenderExtensionInit (void);
 
+
+typedef struct _AnimCurElt {
+    CursorPtr	pCursor;    /* cursor to show */
+    CARD32	delay;	    /* in ms */
+} AnimCurElt;
+
+typedef struct _AnimCur {
+    int		nelt;	    /* number of elements in the elts array */
+    AnimCurElt	*elts;	    /* actually allocated right after the structure */
+} AnimCurRec, *AnimCurPtr;
+
+extern CursorBits animCursorBits;
+
+#define IsAnimCur(c)	    ((c) && ((c)->bits == &animCursorBits))
+#define GetAnimCur(c)	    ((AnimCurPtr) ((c) + 1))
+
 Bool
 AnimCurInit (ScreenPtr pScreen);
 
